// název třídy se skripetm: v tuto chvíli
// je irelevantní - dulezita je metoda main()
class Main
{
	// název vstupní metody - tuto metodu hledá mtasc,
	// když má nastaven parametr -main, musí jít o statickou metodu
	static function main()
	{
		// objekty definované v kostře jsou instancemi třídy
		// MovieClip a jsou přístupné přes proměnnou _root.
		// můžeme jim přidat některé atributy,
		// které budeme později potřebovat
		_root["kruh_0"].v = 6;		// počáteční rychlost (v ixové souřadnici)
		_root["kruh_0"].m = 0.5;	// hmotnost
		_root["kruh_0"].r = 40;		// poloměr
		
		_root["kruh_1"].v = -1;
		_root["kruh_1"].m = 5;
		_root["kruh_1"].r = 40;
		
		// nyní vytvoříme pomocnou instanci třídy MovieClip
		// tato instance bude řídit animaci
		// a kromě toho je použita k vytvoření průhledného
		// klikacího tlačítka nad celým Flashem
		var ctrl:MovieClip = _root.createEmptyMovieClip(
					"controller",
					_root.getNextHighestDepth());
		
		// začíná se kreslit klikací tlačítko
		ctrl.beginFill(0xFFFFFF);
		ctrl.moveTo(0, 0);
		ctrl.lineTo(Stage.width, 0);
		ctrl.lineTo(Stage.width, Stage.height);
		ctrl.lineTo(0, Stage.height);
		ctrl.lineTo(0, 0);
		ctrl.endFill();
		ctrl._alpha = 0;			// plná průhlednost
		
		// definujeme reakci na událost uvolnění tlačitka myši
		ctrl.onRelease = function() {
			// přepneme na požadovanou stránku
			getURL("banner.html", "_self");
		}
		
		// definujeme skript, který bude vyvolán
		// při události generování nového snímku
		ctrl.onEnterFrame = function() {
			// zjednodušíme si život pomocnou proměnnou
			// pro více objektů by se hodilo pole
			var obj1 = _root["kruh_0"];
			var obj2 = _root["kruh_1"];
			
			// ---- TADY UŽ ZAČÍNÁ SAMOTNÁ ANIMACE ----
			// pro ukázku je zvolena jednoduchá fyzika srážek
			
			// nx je pomocná ixová souřadnice
			// jde o souřadnici na kterou se objekt přesune,
			// pokud do ničeho nenarazí
			obj1.nx = obj1._x + obj1.v;
			obj2.nx = obj2._x + obj2.v;
			
			// pomocná proměnná ukazující zda došlo ke kolizi či nikoli
			obj1.collision = false;
			obj2.collision = false;
			
			// kontrola krajních mantinelů
			if (obj1.nx < 0) || (obj1.nx > Stage.width - 2*obj1.r) {
				obj1.v *= -1;
				obj1.collision = true;
			}
			if (obj2.nx < 0) || (obj2.nx > Stage.width - 2*obj2.r) {
				obj2.v *= -1;
				obj2.collision = true;
			}
			
			// kontrola kolize mezi objekty
			if Math.abs(obj1.nx - obj2.nx) < (obj1.r + obj2.r) {
				var u1 = obj1.v;
				var u2 = obj2.v;
				
				// výpočet výsledné rychlosti - uvažuje i různé hmotnosti
				obj1.v = (u1*(obj1.m - obj2.m) + 2*obj2.m*u2) / (obj1.m + obj2.m)
				obj2.v = (u2*(obj2.m - obj1.m) + 2*obj1.m*u1) / (obj1.m + obj2.m)
				obj1.collision = true;
				obj2.collision = true;
			}
			
			// pokud nedošlo ke kolizi, potom objekt skutečně přesuň
			// v opačném případě objekt nepřesouvej.
			// když se toto neudělá, mohl by objekt vyletět ze scény
			if !(obj1.collision) obj1._x = obj1.nx;
			if !(obj2.collision) obj2._x = obj2.nx;
			
			// hrátky s průhledností - po nárazu sniž průhlednost na 10%
			if (obj1.collision) obj1._alpha = 10;
			if (obj2.collision) obj2._alpha = 10;
			
			// pokud není průhlednost 100%, pomalu ji zvyšuj
			if (obj1._alpha < 100) obj1._alpha += 5;
			if (obj2._alpha < 100) obj2._alpha += 5;
		}
	}

}
